//+------------------------------------------------------------------+
//|                             Volume_Price_Momentum_Oscillator.mq4 |
//|                               Copyright  2015, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//|                         Donate / Support:  http://goo.gl/cEP5h5  | 
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |                    
//|                                          mario.jemic@gmail.com   |
//|                     BitCoin: 1MfUHS3h86MBTeonJzWdszdzF2iuKESCKU  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2015, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

extern int one=35;
extern int two=20;
extern int Period=10;

extern color  ColorUp         = Green;
extern color  ColorDown       = Red; //Orange;
extern string UniqueID        = "EmaVariationLines1-alerts";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = false;

extern bool   verticalLinesVisible     = true;
extern string LineIdentifier           = "PMOlines";
extern color  verticalLinesUpColor     = Green; //DeepSkyBlue;
extern color  verticalLinesDownColor   = Red;
extern int    verticalLinesStyle       = STYLE_DOT;
extern int    verticalLinesWidth       = 0;


double PMO[];
double Signal[];
double trend[];

double RawOne[];
double CustomSmoothingFunctionOne[];
double RawTwo[];
double CustomSmoothingFunctionTwo[];



double SmoothingMultiplierOne;
double SmoothingMultiplierTwo;
int init()
{
 IndicatorShortName("RK-PMO-v2");
 
 IndicatorBuffers(7);
 IndicatorDigits(Digits);
 SetIndexStyle(0,DRAW_LINE);
 SetIndexBuffer(0,PMO);
 SetIndexStyle(1,DRAW_LINE);
 SetIndexBuffer(1,Signal);
 SetIndexBuffer(2,RawOne); 
 SetIndexBuffer(3,CustomSmoothingFunctionOne); 
 SetIndexBuffer(4,RawTwo);  
 SetIndexBuffer(5,CustomSmoothingFunctionTwo);
 SetIndexBuffer(6,trend);
 
 
 
 	SmoothingMultiplierOne = (2. / one);
	SmoothingMultiplierTwo = (2. / two);

 return(0);
}

int deinit()
{
// deleteLines();
   if(verticalLinesVisible) deleteLines();


 return(0);
}

int start()
{
 if(Bars<=3) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 int i;
 i=limit;
 while(i>=0)
 { 
    if (Close[i+1]!=0 )
	{
    RawOne[i] =(( (Close[i]/Close[i+1]) * 100. )-100.)  ;
    }
	 i--;
 } 
 
 i=limit;
 while(i>=0)
 { 
 CustomSmoothingFunctionOne[i] = ( RawOne[i] - CustomSmoothingFunctionOne[i+1]) * SmoothingMultiplierOne +  CustomSmoothingFunctionOne[i+1]; 
 RawTwo[i]= 10. *CustomSmoothingFunctionOne[i];
 
   i--;
 } 
 
 
 
  i=limit;
 while(i>=0)
 {     
    CustomSmoothingFunctionTwo[i] = ( RawTwo[i] - CustomSmoothingFunctionTwo[i+1]) * SmoothingMultiplierTwo +  CustomSmoothingFunctionTwo[i+1]; 
    PMO[i]=CustomSmoothingFunctionTwo[i];
   i--;
 } 
 
 
 
  i=limit;
 while(i>=0)
 {
   Signal[i]= iMAOnArray(PMO,0,Period,0,1,i);
   trend[i] = 0;
   if (PMO[i] > Signal[i]) trend[i] = 1;
   if (PMO[i] < Signal[i]) trend[i] = -1;
  
   manageLines(i);  
  i--;
 } 
   
 // manageAlerts();
 return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------

void manageLines(int i)
{
   if (verticalLinesVisible )
   {
         deleteLines(Time[i]);
         if (trend[i]!=trend[i+1])
         {
            if (trend[i+1] == -1 ) drawLines(i,verticalLinesUpColor);
            if (trend[i+1] ==  1 ) drawLines(i,verticalLinesDownColor);
         }
   }
}

 //

void drawLines(int i,color theColor)
{
    string name = LineIdentifier+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//
void deleteLines()
{
   string lookFor       = LineIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteLines(datetime time)
{
   string lookFor = LineIdentifier+":"+time; ObjectDelete(lookFor);
}
